/**
 * Created by asidorov on 23.05.14.
 */

mambo.use(function ($, undefined) {

	mambo.project = mambo.project || {};
	mambo.project.Pixelization = function (pepperPhoto, width, height, enabled) {
		if (!pepperPhoto || !pepperPhoto.length) {return;}
		enabled = typeof enabled === 'boolean' ? enabled : true;
		if ($.browser.msie && $.browser.version <= 9) {
			var pixelSize = 10;
			$.each(pepperPhoto, function () {
				var t = $(this);
				t.attr('src', t.data('src')).css({
					filter: 'progid:DXImageTransform.Microsoft.Blur(pixelradius=' + pixelSize + ', enabled=' + enabled + ')',
					margin: enabled ? ('-' + pixelSize + 'px ' + pixelSize + 'px ' + pixelSize + 'px -' + pixelSize + 'px') : 0
				});
			});
		} else {
			if (!enabled) { return; }
			$.each(pepperPhoto, function () {
				var t = this;
				var imageCssClass = $(this).attr('class') || '';
				var cssText = t.style.cssText || '';
				setTimeout(function () {
					loadImage(t, function(loadedImage, width, height, imageCssClass, cssText){
						var setImgObject = setImg(loadedImage, width, height, imageCssClass, cssText);

						var sourceWidth = setImgObject.sourceWidth;
						var sourceHeight = setImgObject.sourceHeight;
						var dst_ctx = setImgObject.dst_ctx;
						var destX = setImgObject.destX;
						var destY = setImgObject.destY;
						var pixelation = sourceWidth > 100 ? 8 : 5;
						var dst_ctx_orig = setImgObject.dst_ctx_orig;
						var dst_canvas = setImgObject.dst_canvas;

						pixelizeImage(dst_ctx, $(t), sourceWidth, sourceHeight, destX, destY, pixelation, dst_ctx_orig, dst_canvas);
					}, width, height, imageCssClass, cssText);
				}, 10);
			});
		}
	};

	mambo.project.Bluralization = function($images, width, height, blurRaduis) {
		if (!$images || !$images.length) {return;}
		if ($.browser.msie) {
			$.each($images, function () {
				var t = $(this);
				t.attr('src', t.data('src')).css({
					filter: 'progid:DXImageTransform.Microsoft.Blur(pixelradius=' + blurRaduis + ')',
					margin: '-' + blurRaduis + 'px ' + blurRaduis + 'px ' + blurRaduis + 'px -' + blurRaduis + 'px'
				});
			});
		} else {
			$.each($images, function () {
				var t = this;
				var imageCssClass = $(this).attr('class') || '';
				var cssText = t.style.cssText || '';
				setTimeout(function () {
					loadImage(t, function(loadedImage, width, height, imageCssClass, cssText){
						var setImgObject = setImg(loadedImage, width, height, imageCssClass, cssText);

						var sourceWidth = setImgObject.sourceWidth;
						var sourceHeight = setImgObject.sourceHeight;
						var dst_ctx = setImgObject.dst_ctx;
						var destX = setImgObject.destX;
						var destY = setImgObject.destY;
						var dst_ctx_orig = setImgObject.dst_ctx_orig;
						var dst_canvas = setImgObject.dst_canvas;

						bluralizeImage(dst_ctx, destX, destY, sourceWidth, sourceHeight, blurRaduis);
						$(t).replaceWith(dst_canvas);

					}, width, height, imageCssClass, cssText);
				}, 10);
			});
		}
	};

	function pixelizeImage(context, $el, sourceWidth, sourceHeight, destX, destY, pixelation, dst_ctx_orig, dst_canvas) {
		var sourceX = destX,
			sourceY = destY,
			imageData = dst_ctx_orig.getImageData(sourceX, sourceY, sourceWidth, sourceHeight),
			data = imageData.data,
			y, x, n, m, red, green, blue, opacity;

		for (y = 0; y < sourceHeight; y += pixelation) {
			for (x = 0; x < sourceWidth; x += pixelation) {
				red = data[((sourceWidth * y) + x) * 4];
				green = data[((sourceWidth * y) + x) * 4 + 1];
				blue = data[((sourceWidth * y) + x) * 4 + 2];
				opacity = data[((sourceWidth * y) + x) * 4 + 3];

				for (n = 0; n < pixelation; n++) {
					for (m = 0; m < pixelation; m++) {
						if (x + m < sourceWidth) {
							data[((sourceWidth * (y + n)) + (x + m)) * 4] = red;
							data[((sourceWidth * (y + n)) + (x + m)) * 4 + 1] = green;
							data[((sourceWidth * (y + n)) + (x + m)) * 4 + 2] = blue;
							data[((sourceWidth * (y + n)) + (x + m)) * 4 + 3] = opacity;
						}
					}
				}
			}
		}

		context.putImageData(imageData, destX, destY);
		$el.replaceWith(dst_canvas);
		$(dst_canvas).css('display', 'block');
	}

	function loadImage(image, callback) {
		var src = image.src;
		if (!src) {return}

		var img = new Image();
		var loaded = false;

		var args = Array.prototype.slice.call(arguments, 2);
		callback = typeof callback === 'function' ? callback : function(){};
		args.unshift(img);

		img.crossOrigin = '';
		img.onload = function () {
			try {
				callback.apply(null, args);
			} catch (e) {
				if (!loaded) {
					loaded = true;
					try {
						getBinary(src, function (data) {
							i = base64Encode(data);
							img.onload = function () {
								callback.apply(null, args);
							};
							img.src = 'data:image/jpeg;base64,' + i;
						});
					} catch (e) {
					}
				}
			}
		};
		img.src = src;
	}

	function setImg(img, w, h, imageCssClass, cssText) {
		var sourceWidth = w || img.width,
			sourceHeight = h || img.height,
			destX = 0,
			destY = 0;

		var dst_canvas = document.createElement('canvas'),
			dst_ctx = dst_canvas.getContext('2d');

		dst_canvas.width = sourceWidth;
		dst_canvas.height = sourceHeight;
		dst_canvas.className = imageCssClass;
		dst_canvas.style.cssText = cssText;
		dst_ctx.drawImage(img, destX, destY);

		var dst_canvas_orig = document.createElement('canvas'),
			dst_ctx_orig = dst_canvas_orig.getContext('2d');

		dst_canvas_orig.width = sourceWidth;
		dst_canvas_orig.height = sourceHeight;
		dst_ctx_orig.drawImage(img, destX, destY);

		return {
			sourceWidth: sourceWidth,
			sourceHeight: sourceHeight,
			destX: destX,
			destY: destY,
			dst_ctx: dst_ctx,
			dst_ctx_orig: dst_ctx_orig,
			dst_canvas: dst_canvas
		};
	}

	function getBinary(file, callback) {
		var xhr;
		//try {
		//	xhr = new window.ActiveXObject( "Microsoft.XMLHTTP" );
		//} catch( e ) {
		xhr = new (window.XDomainRequest || window.XMLHttpRequest);
		//}
		xhr.open("GET", file, true);
		if (xhr.overrideMimeType) {
			xhr.overrideMimeType("text/plain; charset=x-user-defined");
		}
		if (xhr.setRequestHeader) {
			xhr.setRequestHeader("Content-Type", "text/plain; charset=x-user-defined");
		}
		xhr.onload = function () {
			//if (xhr.readyState == 4 && xhr.status == 200) {
			var response = xhr.response || xhr.responseText;
			callback(response);
			//}
		};
		xhr.send(null);
	}

	function base64Encode(str) {
		var CHARS = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
		var out = "", i = 0, len = str.length, c1, c2, c3;
		while (i < len) {
			c1 = str.charCodeAt(i++) & 0xff;
			if (i == len) {
				out += CHARS.charAt(c1 >> 2);
				out += CHARS.charAt((c1 & 0x3) << 4);
				out += "==";
				break;
			}
			c2 = str.charCodeAt(i++);
			if (i == len) {
				out += CHARS.charAt(c1 >> 2);
				out += CHARS.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));
				out += CHARS.charAt((c2 & 0xF) << 2);
				out += "=";
				break;
			}
			c3 = str.charCodeAt(i++);
			out += CHARS.charAt(c1 >> 2);
			out += CHARS.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));
			out += CHARS.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >> 6));
			out += CHARS.charAt(c3 & 0x3F);
		}
		return out;
	}

	var mul_table = [
		512,512,456,512,328,456,335,512,405,328,271,456,388,335,292,512,
		454,405,364,328,298,271,496,456,420,388,360,335,312,292,273,512,
		482,454,428,405,383,364,345,328,312,298,284,271,259,496,475,456,
		437,420,404,388,374,360,347,335,323,312,302,292,282,273,265,512,
		497,482,468,454,441,428,417,405,394,383,373,364,354,345,337,328,
		320,312,305,298,291,284,278,271,265,259,507,496,485,475,465,456,
		446,437,428,420,412,404,396,388,381,374,367,360,354,347,341,335,
		329,323,318,312,307,302,297,292,287,282,278,273,269,265,261,512,
		505,497,489,482,475,468,461,454,447,441,435,428,422,417,411,405,
		399,394,389,383,378,373,368,364,359,354,350,345,341,337,332,328,
		324,320,316,312,309,305,301,298,294,291,287,284,281,278,274,271,
		268,265,262,259,257,507,501,496,491,485,480,475,470,465,460,456,
		451,446,442,437,433,428,424,420,416,412,408,404,400,396,392,388,
		385,381,377,374,370,367,363,360,357,354,350,347,344,341,338,335,
		332,329,326,323,320,318,315,312,310,307,304,302,299,297,294,292,
		289,287,285,282,280,278,275,273,271,269,267,265,263,261,259];


	var shg_table = [
		9, 11, 12, 13, 13, 14, 14, 15, 15, 15, 15, 16, 16, 16, 16, 17,
		17, 17, 17, 17, 17, 17, 18, 18, 18, 18, 18, 18, 18, 18, 18, 19,
		19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 19, 20, 20, 20,
		20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 20, 21,
		21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 21,
		21, 21, 21, 21, 21, 21, 21, 21, 21, 21, 22, 22, 22, 22, 22, 22,
		22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,
		22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 23,
		23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
		23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
		23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
		23, 23, 23, 23, 23, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
		24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
		24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
		24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24,
		24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24, 24 ];

	function bluralizeImage(context, top_x, top_y, width, height, radius) {
		if (!context || isNaN(radius) || radius < 1) return;
		radius |= 0;

		var imageData = context.getImageData( top_x, top_y, width, height );
		var pixels = imageData.data;

		var x, y, i, p, yp, yi, yw, r_sum, g_sum, b_sum,
			r_out_sum, g_out_sum, b_out_sum,
			r_in_sum, g_in_sum, b_in_sum,
			pr, pg, pb, rbs;

		var div = radius + radius + 1;
		var widthMinus1  = width - 1;
		var heightMinus1 = height - 1;
		var radiusPlus1  = radius + 1;
		var sumFactor = radiusPlus1 * ( radiusPlus1 + 1 ) / 2;

		var stackStart = new BlurStack();
		var stack = stackStart;
		for ( i = 1; i < div; i++ ) {
			stack = stack.next = new BlurStack();
			if ( i == radiusPlus1 ) var stackEnd = stack;
		}
		stack.next = stackStart;
		var stackIn = null;
		var stackOut = null;

		yw = yi = 0;

		var mul_sum = mul_table[radius];
		var shg_sum = shg_table[radius];

		for ( y = 0; y < height; y++ ) {
			r_in_sum = g_in_sum = b_in_sum = r_sum = g_sum = b_sum = 0;

			r_out_sum = radiusPlus1 * ( pr = pixels[yi] );
			g_out_sum = radiusPlus1 * ( pg = pixels[yi+1] );
			b_out_sum = radiusPlus1 * ( pb = pixels[yi+2] );

			r_sum += sumFactor * pr;
			g_sum += sumFactor * pg;
			b_sum += sumFactor * pb;

			stack = stackStart;

			for( i = 0; i < radiusPlus1; i++ ) {
				stack.r = pr;
				stack.g = pg;
				stack.b = pb;
				stack = stack.next;
			}

			for( i = 1; i < radiusPlus1; i++ ) {
				p = yi + (( widthMinus1 < i ? widthMinus1 : i ) << 2 );
				r_sum += ( stack.r = ( pr = pixels[p])) * ( rbs = radiusPlus1 - i );
				g_sum += ( stack.g = ( pg = pixels[p+1])) * rbs;
				b_sum += ( stack.b = ( pb = pixels[p+2])) * rbs;

				r_in_sum += pr;
				g_in_sum += pg;
				b_in_sum += pb;

				stack = stack.next;
			}


			stackIn = stackStart;
			stackOut = stackEnd;
			for ( x = 0; x < width; x++ ) {
				pixels[yi]   = (r_sum * mul_sum) >> shg_sum;
				pixels[yi+1] = (g_sum * mul_sum) >> shg_sum;
				pixels[yi+2] = (b_sum * mul_sum) >> shg_sum;

				r_sum -= r_out_sum;
				g_sum -= g_out_sum;
				b_sum -= b_out_sum;

				r_out_sum -= stackIn.r;
				g_out_sum -= stackIn.g;
				b_out_sum -= stackIn.b;

				p =  ( yw + ( ( p = x + radius + 1 ) < widthMinus1 ? p : widthMinus1 ) ) << 2;

				r_in_sum += ( stackIn.r = pixels[p]);
				g_in_sum += ( stackIn.g = pixels[p+1]);
				b_in_sum += ( stackIn.b = pixels[p+2]);

				r_sum += r_in_sum;
				g_sum += g_in_sum;
				b_sum += b_in_sum;

				stackIn = stackIn.next;

				r_out_sum += ( pr = stackOut.r );
				g_out_sum += ( pg = stackOut.g );
				b_out_sum += ( pb = stackOut.b );

				r_in_sum -= pr;
				g_in_sum -= pg;
				b_in_sum -= pb;

				stackOut = stackOut.next;

				yi += 4;
			}
			yw += width;
		}


		for ( x = 0; x < width; x++ ) {
			g_in_sum = b_in_sum = r_in_sum = g_sum = b_sum = r_sum = 0;

			yi = x << 2;
			r_out_sum = radiusPlus1 * ( pr = pixels[yi]);
			g_out_sum = radiusPlus1 * ( pg = pixels[yi+1]);
			b_out_sum = radiusPlus1 * ( pb = pixels[yi+2]);

			r_sum += sumFactor * pr;
			g_sum += sumFactor * pg;
			b_sum += sumFactor * pb;

			stack = stackStart;

			for( i = 0; i < radiusPlus1; i++ ) {
				stack.r = pr;
				stack.g = pg;
				stack.b = pb;
				stack = stack.next;
			}

			yp = width;

			for( i = 1; i <= radius; i++ ) {
				yi = ( yp + x ) << 2;

				r_sum += ( stack.r = ( pr = pixels[yi])) * ( rbs = radiusPlus1 - i );
				g_sum += ( stack.g = ( pg = pixels[yi+1])) * rbs;
				b_sum += ( stack.b = ( pb = pixels[yi+2])) * rbs;

				r_in_sum += pr;
				g_in_sum += pg;
				b_in_sum += pb;

				stack = stack.next;

				if( i < heightMinus1 )
				{
					yp += width;
				}
			}

			yi = x;
			stackIn = stackStart;
			stackOut = stackEnd;
			for ( y = 0; y < height; y++ ) {
				p = yi << 2;
				pixels[p]   = (r_sum * mul_sum) >> shg_sum;
				pixels[p+1] = (g_sum * mul_sum) >> shg_sum;
				pixels[p+2] = (b_sum * mul_sum) >> shg_sum;

				r_sum -= r_out_sum;
				g_sum -= g_out_sum;
				b_sum -= b_out_sum;

				r_out_sum -= stackIn.r;
				g_out_sum -= stackIn.g;
				b_out_sum -= stackIn.b;

				p = ( x + (( ( p = y + radiusPlus1) < heightMinus1 ? p : heightMinus1 ) * width )) << 2;

				r_sum += ( r_in_sum += ( stackIn.r = pixels[p]));
				g_sum += ( g_in_sum += ( stackIn.g = pixels[p+1]));
				b_sum += ( b_in_sum += ( stackIn.b = pixels[p+2]));

				stackIn = stackIn.next;

				r_out_sum += ( pr = stackOut.r );
				g_out_sum += ( pg = stackOut.g );
				b_out_sum += ( pb = stackOut.b );

				r_in_sum -= pr;
				g_in_sum -= pg;
				b_in_sum -= pb;

				stackOut = stackOut.next;

				yi += width;
			}
		}
		context.putImageData(imageData, top_x, top_y);
	}

	function BlurStack() {
		this.r = 0;
		this.g = 0;
		this.b = 0;
		this.a = 0;
		this.next = null;
	}

	mambo.ready('{mambo.project}Pixelization');
});