/**
 * @copyright Mamba ( http://corp.mamba.ru/ )
 */

/*global window: false, jQuery: false, mambo: false */
/*jslint white: true, undef: true, sloppy: true, forin: true, plusplus: true, maxerr: 50, indent: 4 */

mambo.use('{mambo.ui}Location', '{mambo.ui}Overlay', '{mambo.ui}Input', '{mambo.utils}Common', '{mambo.ui}Alert', '{mambo.ui}BlockRejected', 'jsCore/mamba-app/Modal', function ($) {

	mambo.project = mambo.project || {};
	function Personal(params){
		
		params = params || {};
		
		var $PrivateDataBlock;
		var $EditLink;
		var popupIsOpenOnLoad = 0;
		
		var saving = false;
		var ajax;
		
		function showPopup(link, $relativeBox, fromListLayerFlag) {
			var url = link.href;
			if (ajax) {
				ajax.abort();
			}
			ajax = $.get(url, '', function (R){
				if (R) {
					var html = R.responseText || R;
					$relativeBox.hide().after(html);
					if (fromListLayerFlag){
						$('#PrivateDataForm').find('.selectFromList').data('fromListLayerFlag','true');
					}
					bindForm(url);
				}
			});
		}

		function checkIncognitoUserCurrentPhotoUrl () {
			if ( Mb.Storage.getLocalStorage('incognitoUserCurrentPhotoUrl') !== null ) {
				var incognitoUserCurrentPhotoUrl = Mb.Storage.getLocalStorage("incognitoUserCurrentPhotoUrl");
				window.location = incognitoUserCurrentPhotoUrl;
				Mb.Storage.removeLocalStorage('incognitoUserCurrentPhotoUrl');
			}
		}

		function editGreetingMessage(){

            var $box = $('.b-profile-cloud'),
                $link = $('.open_message', $box),
                $link_reject = $('.b-reject-link', $box);
                $text = $('.b-profile-cloud-inner', $box),
                $textInner = $('.b-profile-cloud-inner__message', $text);
                $form = $('form', $box),
                $textarea = $('textarea[name=aboutme]', $form),
                $submit = $('[type="submit"]', $form),
                $reset = $('input.reset', $form);



            if ($form.length) {
                $text.on('click', function(e){
                    $box.toggleClass('__state__edit-content');
                    $textarea.focus();
                    e.preventDefault();
                });

                $reset.on('click', function(e){
                    $box.toggleClass('__state__edit-content');
                    e.preventDefault();
                });

                $form.on('submit', function(e){
                    e.preventDefault();

                    $.ajax({
                        url: $form.attr('action'),
                        type: $form.attr('method'),
                        data: $form.serialize(),
                        dataType: 'json',
                        success: function(R)
                        {
                            var html = R.d.aboutme,
                                text = html.replace(/<br[^>]*>/ig, '\n'),
                                length = R.d.aboutme.length;

                            function escapeHtml(text) {
                                return text
                                    .replace(/&/g, "&amp;")
                                    .replace(/</g, "&lt;")
                                    .replace(/>/g, "&gt;")
                                    .replace(/"/g, "&quot;")
                                    .replace(/'/g, "&#039;");
                            }

                            $textInner.html(escapeHtml(text).replace(/\n/g, '<br>'));
                            $textarea.val(text);

                            if(!length) {
                                $box.addClass('__state__block-empty');
                            }
                            else {
                                $box.removeClass('__state__block-empty');
                            }

                            $box.removeClass('__state__edit-content');

                            $link.hide();
                            $link_reject.hide();
                            $box.removeClass('reject')
                        }
                    });
                });

                $textarea.counter();
            }

            mambo.ui.BlockRejected({
                linkSelector: '.js-link-greeting-rejected',
                layer: $('.js-layer-greeting-rejected'),
                textarea: $textarea,
                $form: $form,
                submit: $submit
            });
        }









        function init(){
			var locs, href, l, s, i;
			$PrivateDataBlock = $('#PrivateDataBlock');
			$EditLink = $PrivateDataBlock.find('.editLink');
			if (params.byLocation && !popupIsOpenOnLoad) {
				locs = [];
				href = window.location.href;
				if (typeof params.byLocation === 'string') {
					locs.push(params.byLocation);
				} else {
					locs = params.byLocation;
				}
				l = locs.length;
				for (i = 0; i < l; i++) {
					s = locs[i];
					if (href.indexOf(s) > -1) {
						popupIsOpenOnLoad = 1;
						showPopup($EditLink.get(0),$PrivateDataBlock,true);
						break;
					}
				}
			}
			if(params.openOnLoad && !popupIsOpenOnLoad){
				popupIsOpenOnLoad = 1;
				showPopup($EditLink.get(0),$PrivateDataBlock,true);
			}
			$EditLink.unbind('click.edit').bind('click.edit', function(e){
				e.preventDefault();
				var that = this;
				var requestTop100 = $.post('/my/top/ajax.phtml?action=hasTopPhotos',function(R){
					if(R){
						var layerTop100Reset = mambo.ui.Overlay('#top100reset', {
							url: '/my/top/ajax.phtml?action=layerResetWarning'
						}).open();
					}
				}).complete(function(){
					showPopup(that ,$PrivateDataBlock);
				});
			});
			checkIncognitoUserCurrentPhotoUrl();
            editGreetingMessage();
		}
		
		function bindForm(url){
			var loc = mambo.ui.Location.get('#LSPersonal');
			if (loc) {
				loc.selector();
			}
			
			var $PrivateDataForm = $('#PrivateDataForm');
			var $OldCancelBtn = $PrivateDataForm.find('input[name="cancel"]'),
				OldCancelBtn = $OldCancelBtn[0];
			
			var $SubmitBtn = $('input[name="save"]');
			var CancelBtn = document.createElement('input');
			CancelBtn.type = 'reset';
			CancelBtn.className = OldCancelBtn.className;
			CancelBtn.name = OldCancelBtn.name;
			CancelBtn.value = OldCancelBtn.value;
			
			var $CancelBtn = $(CancelBtn).insertAfter($OldCancelBtn);
			$OldCancelBtn.remove();
			
			$CancelBtn.bind('click', function(e){
				$PrivateDataForm.hide();
				$PrivateDataBlock.show();
			});
			
			$SubmitBtn.bind('click', function(e){
				if ($.browser.msie) {
					$PrivateDataForm.trigger('submit');
					e.preventDefault();
				}
			});

			$("input[name=name]", $PrivateDataForm).counter();

			$PrivateDataForm.bind('submit', function(e){
				$SubmitBtn.prop('disabled', true);
				$CancelBtn.prop('disabled', true);
				
				if (!saving) {
					
					saving = true;
					
					if (window.opera) { // Opera Bug Fix
						$('#LSSelect').replaceWith($('#LSSelect').clone());
					}
					var data = $PrivateDataForm.serialize();
					
					$.ajax({
						url: url,
						type: "POST",
						cache: false,
						data: data,
						success: function (R){
							saving = false;
							if (R) {
								if (R.XForms && R.XForms.Personal) {
									var er = R.XForms.Personal;
									
									checkError($('#AP-Birthday'), er.birthdate);
									checkError($('#AP-Name'), er.name);
									checkError($('#AP-LivePlace'), er.location);
								} else {
									var html = R.responseText || R;
									$PrivateDataBlock.after(html);
									$PrivateDataBlock.remove();
									$PrivateDataForm.remove();
									init();
								}
							}
							$SubmitBtn.prop('disabled', false);
							$CancelBtn.prop('disabled', false);
						},
						error: function(){
							saving = false;
							$PrivateDataForm.remove();
							$PrivateDataBlock.show();
							alert($.define('mambo.lang.error.server'));
						}
					});
					
				}
				
				e.preventDefault();
			});
		}
		
		
		function checkError($obj, er){
			if (er) {
				$obj.addClass('invalid').find('.error').text(er);
			} else {
				$obj.removeClass('invalid');
			}
		}
		
		
		/*
		 * Run
		 */
		
		init();
		
	}
	
	
	function Sections(params){
	
		params = params || {};
		
		function bindForm(href, $block, $form){
			var $Submit = $form.find('input[type="submit"]');
			var $Cancel = $form.find('input[name="cancel"]');
			
			if ($block && $block.length) {
				$Cancel.replaceWith('<input type="reset" value="' + $Cancel.val() + '" />');
				$Cancel = $form.find('input[type="reset"]');
				
				$Cancel.bind('click', function(e){
					e.preventDefault();
					$block.show();
					$form.remove();
					operaFix();
				});
			} else {
				$Cancel.bind('click', function(e){
					e.preventDefault();
					$form.append('<input type="hidden" name="cancel" value="Отмена" />').trigger('submit');
				});
			}
			
			bindElms($form);
			
			$form.bind('submit', function(e){
				e.preventDefault();
				
				$.post(href, $form.serialize(), function (R){
					if (R) {
						if (R.XForms) {//Error
							var error = R.XForms[$form.attr('name')];
							var top, top2;
							$form.find('.invalid').removeClass('invalid');
							for(var i in error){
								var $vTarget = $form.find('[name^="'+i+'"]').parents('.v-target').removeClass('valid').addClass('invalid');
								$vTarget.find('.error').html(error[i]);
								top2 = $vTarget.offset().top;
								if(!top || top2 < top){
									top = top2;
								}
							}
							scrollTop(top);
						} else {
							R = R.responseText || R;
							$form.parents('.BlockEdited').html(R);
							bindBlocks();
						}
					}
				});
			});
			
			operaFix();
		}
		
		
		function bindBlocks(){
			var $EditLinks = $('a.btn-edit');
			
			$EditLinks.each(function(){
				var $this = $(this);
				
				if ($this.attr('data-binded')) {
					return;
				}
				
				$this.attr('data-binded', true);
				
				var $block = $this.parents('.be-result');
				var $form;
				var requestFlag = 0;
				
				$this.bind('click', function(e){
					e.preventDefault();
					if(requestFlag){
						return;
					}
					
					var href = $this.attr('href');
					
					requestFlag=1;
					var request = $.get(href, function (R){
						if (R) {
							R = R.responseText || R;
							$block.hide().after(R);
							$form = $block.next();
							bindForm(href, $block, $form);
						}
						requestFlag=0;
					});
					request.error(function(){
						requestFlag=0;
					});
				});
			});
			
			operaFix();
		};
		
		function getParameterByName(name){
			name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
			var regexS = "[\\?&]" + name + "=([^&#]*)";
			var regex = new RegExp(regexS);
			var results = regex.exec(window.location.search);
			if(results == null){
				return "";
			}else{
				return decodeURIComponent(results[1].replace(/\+/g, " "));
			}
		}
		
		function openBlockOnLoad(){
			var paramFromURL = getParameterByName('blockEditedAnketa');
			if(paramFromURL.length){
				var $boxToOpen = $('#block-edited-anketa-'+paramFromURL);
				if($boxToOpen.length){
					$boxToOpen.find('a.btn-edit').trigger('click');
					$(window).scrollTop($boxToOpen.offset().top);
				}
			}
		}
		
		
		function bindElms($form){
			$form.find('select._autoselect_').unbind('change.autoselect').bind('change.autoselect', function(e){
				var $this = $(this);
				var child = $this.attr('data-autoselect-child');
				
				if (child) {
					var $Child = $(child);
					var $ChildInp = $Child.find('select');
					var name = $this.attr('name');
					var url = $this.attr('data-autoselect-url');
					var val = $this.val();
					
					$Child.slideUp();
					if (val != 0) {
						$.get('/ajax/select.phtml', {
							id: val,
							select: name
						}, function (R){
							if (R && R.d) {
								var html = '<option value="0"> </option>';
								var d = R.d;
								for (var i = 0, l = d.length; i < l; i++) {
									html += '<option value="' + d[i].value + '">' + d[i].text + '</option>';
								}
								$ChildInp.html(html);
								$Child.slideDown();
							}
						});
					} else {
						$ChildInp.html('');
					}
				}
			});

			$form.find('textarea').counter();

			$form.find('._toggler_').each(function(i){
				var $this = $(this);
				var $link = $this.find('.t-toggle');
				var $block = $this.find('.t-element');
				
				$link.bind('click', function(e){
					e.preventDefault();
					if($block.css('display') != 'none'){
						$this.add($link).removeClass('expand').addClass('collapsed');
						$block.slideUp('fast');
					} else {
						$this.add($link).removeClass('collapsed').addClass('expand');
						$block.slideDown('fast');
					}
				});
				
				if($this.hasClass('expand') || $link.hasClass('expand')){
					$this.add($link).removeClass('collapsed').addClass('expand');
					$block.show();
				} else {
					$this.addClass('collapsed');
					$block.hide();
				}
			});
			
			
			(function(){
				var $Count = $form.find('.TextareasCount');
				
				if (!$Count.length) {
					return;
				}
				
				var $Textareas = $form.find('textarea');
				var timer;
				
				function check(){
					var count = 0;
					$Textareas.each(function(i){
						if ($(this).val()) {
							count++;
						}
					});
					$Count.html(count);
				}
				
				function addCheck(){
					if (timer) {
						return;
					}
					timer = setTimeout(function(){
						check();
						timer = 0;
					}, 200);
				}
				
				$Textareas.bind('change keyup click', addCheck);
				
				check();
			})();
		}
		
		
		function operaFix(){
			if ($.browser.opera) {// Opera Bug. Reflow It!
				document.body.style.overflow = 'hidden';
				document.body.offsetHeight;
				document.body.style.overflow = '';
			}
		}
		
		/*
		 * Run
		 */
		
		var $Form = $('form.Block-Edit');
		$Form.each(function(i){
			$this = $(this);
            var url = $this.attr('action') ? $this.attr('action') : window.location.href;
			bindForm(url, null, $this);
		});
		bindBlocks();
		openBlockOnLoad();
	}


	var topSlidePanelHeight = $('.ui-userbar-cont').outerHeight() || 0;// need for scrollTo correction
	function scrollTop(top){
		var $Frame = ($.browser.webkit) ? $('body') : $('html');
		if (top) {
			$Frame.animate({
				scrollTop: (top - topSlidePanelHeight)
			}, {
				speed: 'normal',
				easing: 'easeOutBack'
			});
		}
	}
	
	function initVipGiftToUser() {
		var $bHint = $('.js-vip-gift-to-user .js-button-hint');
        if(!$bHint.hasClass('js-vip-my-anketa')){
            var removeSelected = function() {$bHint.removeClass('selected');};
            $bHint.click(function(e) {
                e.preventDefault();
                $bHint.toggleClass('selected');
                _.delay(function() { $(window)[$bHint.hasClass('selected') ? 'one' : 'off']('click', removeSelected); }, 10);
            });
        }
	}
	
	mambo.project.Anketa = mambo.project.AnketaPersonal = function(params){
		Personal(params);
		initVipGiftToUser();
		if(!params.lang){
			return;
		}
		Sections(params);
	};



	mambo.use('{mambo.ui}Input', function ($) {
		var $anketaBoxes = $('.b-anketa'),
			textAreaManager = {},
			rejectQuestionModal,
			s_post, t;
		t = mambo.utils.parseStringGetParams(mambo && 'sPost' in mambo ? mambo.sPost : '');
		if ('s_post' in t) {
			s_post = t.s_post;
		}
		$anketaBoxes.each(function () {
			var $anketaBox = $(this);
			if ($anketaBox.hasClass('questions')) {
				initQuestionsBlock($anketaBox);
				return;
			}

			var $editLink = $anketaBox.find('.js-edit-link'),

				$anketaContentBox = $anketaBox.find('.b-anketa_inset-info'),
				$anketaEditBox = $anketaBox.find('.b-anketa_form_edit'),

				editModeClass = 'edit-mode',
				anketaBoxEmptyClass = 'block-empty',
				urlForGetAndSaveData = $editLink.attr('href'),

				requestInProgress = 0,
				topSlidePanelHeight = $('.ui-userbar-cont').outerHeight() || 0;// need for scrollToPanel correction

			function scrollTop(top) {
				var $Frame = ($.browser.webkit) ? $('body') : $('html');
				if (top) {
					$Frame.animate({
						scrollTop: (top - topSlidePanelHeight)
					}, {
						speed: 'normal',
						easing: 'easeOutBack'
					});
				}
			}

			$editLink.on('click', function (e) {
				e.preventDefault(e);
				if (requestInProgress) {
					return;
				}
				$.get(urlForGetAndSaveData, function (R) {
					if (R && R.d && R.d.tpl) {
						$anketaEditBox.html(R.d.tpl);// set new content
						initEditFormEvents();// init events for new content
						$anketaBox.addClass(editModeClass);// change view
						countTarget($anketaBox);
					}
				}, 'json')
					.complete(function () {
						requestInProgress = 0;// set request in progress flag
					});
			});

			// edit form events
			function initEditFormEvents() {
				var $exitEditModeLink = $anketaBox.find('.js-exit-edit-mode'),
					$saveBoxForm = $anketaBox.find('.js-save-form');

                var $otherCheckbox = $saveBoxForm.find('input[value="Other"]');

				$exitEditModeLink.on('click', function (e) {
					e.preventDefault(e);
					if (requestInProgress) {
						return;
					}
					$anketaEditBox.empty();// empty edit box
					$anketaBox.removeClass(editModeClass);// change view
				});

                $otherCheckbox.on('click', function (e) {
                    $(this).parents('div:first').next().find('textarea').val('');
                });

				$saveBoxForm.on('submit', function (e) {
					e.preventDefault(e);
					if (requestInProgress) {
						return;
					}
					requestInProgress = 1;// set request in progress flag
                    $otherCheckbox.each(function() {
                        var $cb = $(this);
                        var $textarea = $cb.closest('div').next().find('textarea');
                        if (!$cb.prop('checked')) {
                            $textarea.val('');
                        }
                    });
                    
					$.post(urlForGetAndSaveData, $saveBoxForm.serialize(), function (R) {
						if (R && R.XForms) {
							var error = R.XForms[$saveBoxForm.attr('name')],
								top, top2, i, $vTarget;
							$saveBoxForm.find('.invalid').removeClass('invalid');
							for (i in error) {
								$vTarget = $saveBoxForm.find('[name^="' + i + '"]').parents('.b-anketa_field').removeClass('valid').addClass('invalid');
								$vTarget.find('.error').html(error[i]);
								top2 = $vTarget.offset().top;// for scroll to
								if (!top || top2 < top) {
									top = top2;
								}
							}
							scrollTop(top);// scroll to
						} else if (R && R.d && R.d.tpl) {
							$anketaContentBox.html(R.d.tpl);
							$anketaBox.removeClass(anketaBoxEmptyClass);
							$anketaEditBox.empty();// empty edit box
							$anketaBox.removeClass(editModeClass);// change view
							$anketaBox.trigger('submit_success');
							/*sTODO https://redmine.mamba.ru/issues/79064*/
							$(".main-block-container").css("position","static");
							function normaliseFooter(){
                                $(".main-block-container").css("position","relative");
							}
                            setTimeout(normaliseFooter, 1000);

						} else {
							$anketaBox.addClass(anketaBoxEmptyClass);
						}
					}, 'json')
						.complete(function () {
							requestInProgress = 0;// set request in progress flag
						});
				});

				$saveBoxForm.find('textarea').counter();

				(function () {
					var $Count = $saveBoxForm.find('.TextareasCount'),
						$Textareas,
						timer;

					function check() {
						var count = 0;
						$Textareas.each(function () {
							if ($(this).val()) {
								count++;
							}
						});
						$Count.html(count);
					}

					function addCheck() {
						if (timer) {
							return;
						}
						timer = setTimeout(function () {
							check();
							timer = 0;
						}, 200);
					}

					if ($Count.length) {
						$Textareas = $saveBoxForm.find('textarea');
						$Textareas.on('input', addCheck);
						check();
					}
				}());

				function checkOther(e) {
					if ((e.type === 'blur' && $.trim(this.value) === '') || e.type === 'focus') {
						$(this).closest('.b-anketa_field-content').find('input[value="Other"]')[e.type === 'focus' ? 'attr' : 'removeAttr']('checked', 'checked');
					}
				}

				$('#real_sexexcitation textarea')
					.on('focus', checkOther)
					.on('blur', checkOther);
			}

			initEditFormEvents();// init on load
		});

		function initTextArea($anketaBox) {
			var $textArea = $anketaBox.find('#content_form_textarea');
			textAreaManager.$input = $textArea.find('textarea').counter();
			
			textAreaManager.createOrReplace = function(value, questionId) {
				var params;
				textAreaManager.$addButton.addClass('disabled');
				$textArea.find('.textarea').removeClass('invalid');
				// if in edit-mode
				if (questionId) {
					params = {
						url: '/ajax/question.phtml',
						type: 'post',
						data: {
							action: 'edit',
							s_post: s_post,
							post_id: questionId,
							question: value
						},
						dataType: 'json',
						cache: false
					};
					
				} else { // means creating
					params = {
						url: '/ajax/question.phtml',
						type: 'post',
						data: {
							action: 'create',
							s_post: s_post,
							question: value
						},
						dataType: 'json',
						cache: false
					};
				}
				return $.ajax(params).done(function(res) {
					textAreaManager.resetAndHide();
					if (res.s) {
						if (res.d && res.d.tpl) {
							$anketaBox.replaceWith(res.d.tpl);
                            $anketaBox = $('#Anketa_Questions');
							initQuestionsBlock($anketaBox);
						} else {
							window.location.reload();
						}
					} else if (res.e) {
						$textArea.find('.textarea .error').text(res.e);
						$textArea.find('.textarea').addClass('invalid');
						$textArea.one('counter', function() {
							$anketaBox.find('.textarea').removeClass('invalid');
						});
						mambo.ui.Alert(res.e, {
							type: 'error'
						});
					}
				}).fail(function(err) {
					mambo.ui.Alert(err.message, {
						type: 'error'
					});
				}).always(function() {
					textAreaManager.$addButton.removeClass('disabled');
				});
			};
	
			textAreaManager._$addButton = textAreaManager.$addButton = $textArea.find('.js-add-question');
			$textArea.on('click', '.js-exit-edit-mode', function(e){
				e.preventDefault();
				textAreaManager.resetAndHide();
			});
			textAreaManager.$input.on('counter', function(e, p) {
				var $el = $(this),
					oldVal = textAreaManager._text && textAreaManager._text.data('oldText'),
					newVal = $.trim($el.val());
				textAreaManager.$addButton.toggleClass('disabled', (p.count === 0) || !newVal || (oldVal === newVal));
			});
			textAreaManager.$addButton.click(function(e) {
				var pp;
				e.preventDefault();
				if ($(this).hasClass('disabled')) return;
				pp = String($textArea.parent().data('params')||'').split('#');
				textAreaManager.createOrReplace($.trim(textAreaManager.$input.val()), pp[0]);
			});
			textAreaManager.resetAndHide = function(keepButton) {
				$textArea.addClass('hide').detach();
				$anketaBox.removeClass('edit-mode');
				if (this._text) {
					this._text.removeClass('edit');
				}
				delete this._text;
				$textArea.find('.textarea').removeClass('invalid');
				textAreaManager.$input.removeAttr('style').val('').triggerHandler('input.counter');
				if (!keepButton) textAreaManager.$addButton = textAreaManager._$addButton;
			};
			textAreaManager.toggleAt = function($el, isEdit, $textContent) {
				if (!$el) return;
				var at = $el, textEl = ($textContent || $el).find('.question-text');
				this.resetAndHide(true);
				if (isEdit) {
					this._text = $el;
					var txt = $.trim($(textEl[textEl.length - 1]).clone().children().remove().end().text());
					$el.addClass('edit').data('oldText', txt);
					textAreaManager.$input.val(txt).triggerHandler('input.counter');
					at = $textContent ? $el : $el.find('.js-add-q-placeholder');
				} else {
					$anketaBox.addClass('edit-mode');
				}
				$textArea.appendTo(at).removeClass('hide');
				textAreaManager.$input.focus();
			};
		}

		function initQuestionsBlock($anketaBox) {
			$anketaBox.off();
			initTextArea($anketaBox);
			$anketaBox.on('click', '.js-edit-link', function(e) {
				e.preventDefault();
				if ($(this).hasClass('disabled')) return;
				textAreaManager.toggleAt($anketaBox.find('.bx-anketa-form.js-add-q-placeholder'));
			});
			$anketaBox.on('click', '.togglink', function(e) {
				e.preventDefault();
				$(this).closest('.questionBlock').find('.question-text').toggleClass('hide');
			});
			$anketaBox.on('click', '.js-q-edit', function(e) {
				e.preventDefault();
				var $el = $(this);
				textAreaManager.toggleAt($el.closest('.in'), true);
			});
			$anketaBox.on('click', '.js-q-delete', function() {
				var $el = $(this).closest('.questionBlock');
				if ($el.hasClass('confirm')) {
					return;
				}
				var reset = function reset() {
					$el.removeClass('confirm');
					$el.off('mouseleave', reset);
					$(window).off('click', reset);
				};
				$el.addClass('confirm');
				_.defer(function() {
					$el.one('mouseleave', reset);
					$(window).one('click', reset);
				});
			});
			$anketaBox.find('.js-q-delete-confirm').on('click', function() {
				var $el = $(this);
				$el.addClass('disabled');
				$.ajax({
					url: '/ajax/question.phtml',
					type: 'post',
					data: {
						action: 'delete',
						s_post: s_post,
						post_id: $el.data('param')
					},
					// a workaround to prevent refreshing the page
					dataFilter: function (d) { try { d = JSON.parse(d); delete d.r; return JSON.stringify(d); } catch(ex) {} },
					dataType: 'json',
					success: function (R) {
						if (R.s) {
							if (R.d && R.d.tpl) {
								$anketaBox.replaceWith(R.d.tpl);
                                $anketaBox = $('#Anketa_Questions');
								initQuestionsBlock($anketaBox);
							} else {
								window.location.reload();
							}
						} else if (R.e) {
							mambo.ui.Alert(R.e, {
								type: 'error'
							});
						}
					}
				}).always(function() {
					$el.removeClass('disabled');
				});
			});
			$anketaBox.on('click', '.js-q-like', function(e) {
				var $el = $(this),
					prm = String($el.data('params')||'').split('#');
				// if user is unauthorized
				if (!prm.length) {return;}
				// else
				e.preventDefault();
				var add = $el.toggleClass('selected').hasClass('selected'),
					cnt = +$el.find('.count i').text();
				$.ajax({
					url: '/diary/like.phtml',
					type: 'post',
					data: {
						action: prm[0],
						author_id: prm[1],
						post_id: prm[2],
						comment_id: prm[3],
						s_post: s_post
					},
					dataType: 'json',
					cache: false,
                    success: function(res) {
                        if (res.s) {
                            prm[0] = add ? 'dis'+prm[0] : prm[0].replace('dis', '');
                            $el.find('.count i').text(add ? ++cnt : --cnt);
                            $el.data('params', prm.join('#'));
                        } else {
                            $el.removeClass('selected');
                        }
                    }
				}).fail(function() {
					$el.removeClass('selected');
				});
			});
			$anketaBox.on('click', '.js-link-question-rejected', function(e) {
				var $el = $(this),
					$block = $el.closest('.in'),
					prm = String($block.find('.js-add-q-placeholder').data('params') || '').split('#');
				// if user is unauthorized
				if (!prm.length) {return;}
				// else
				e.preventDefault();
				if (!rejectQuestionModal) {
					var modalParams = {
						modalClass: 'modal-rejected',
						modalWidth: 420,
						content: $('.js-layer-question-rejected')
					};
					rejectQuestionModal = Modal(modalParams);
					$(rejectQuestionModal.getBox()).on('click', '.js-save-rejected-question', function(e) {
						e.preventDefault();
						textAreaManager.createOrReplace($.trim(textAreaManager.$input.val()), prm[0]).done(function () {
							rejectQuestionModal.hide();
						});
					});
					rejectQuestionModal.on('hide', function () {
						textAreaManager.resetAndHide();
					});
				}
				textAreaManager.$addButton = $(rejectQuestionModal.getBox()).find('.js-save-rejected-question');
				textAreaManager.toggleAt($(rejectQuestionModal.getBox()).find('.textarea'), true, $block);
				rejectQuestionModal.show();
			});
		}

		function getParameterByName(name) {
			name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
			var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
				results = regex.exec(window.location.search);
			return results == null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
		}

		(function openBlockOnLoad() {
			var paramFromURL = getParameterByName('blockEditedAnketa');

			if (paramFromURL.length) {
				switch (paramFromURL) {
                    case 'questions':
						$('.js-edit-link', document.getElementById('Anketa_Questions')).trigger('click');
						break;
					case 'dating':
						$('.js-edit-link', document.getElementById('Anketa_Search')).triggerHandler('click');
						break;
					case 'type':
						$('.js-edit-link', document.getElementById('Anketa_About')).triggerHandler('click');
						break;
					case 'about':
						$('.messageMe', document.getElementById('aboutme')).triggerHandler('click');
						break;
					default:
						break;
				}
			}
		}());

		//ограничение выбранных целей знакомства (5 штук)
		function countTarget($anketaBox) {

			var targetEL = $(".js-target_checkbox", $anketaBox),
				countEL = targetEL.filter("[checked]"),
				count = countEL.length,
				countLength = 5,
				clNoChecked = 'js-no_checked';

			function countLimit(counter) {
				var less = counter < countLength,
					el = $(".js-no_checked", $anketaBox);
				el[less ? 'removeClass' : 'addClass']("target_disabled");
				$(".js-target_checkbox", el)[less ? 'removeAttr' : 'attr']('disabled', 'disabled');
			}

			countEL.removeClass(clNoChecked);
			countLimit(count);
			targetEL.on("click", function () {
				count = count + (this.checked ? 1 : -1);
				$(this).closest("label")[this.checked ? 'removeClass' : 'addClass'](clNoChecked);
				countLimit(count);
			});
		}

		(function initSocialBox() {
			var $box = $('#Anketa_Social'),
				$closeBtn = $box.find('.js-close-box'),
				$socialBottomBlock = $box.find('.js-social-bottom'),
				$confidenceBlock = $box.find('.js-confidence-block'),
				$socialUnitsBlock = $box.find('.js-social-units-block'),
				$confidenceLayer = mambo.ui.Overlay.open('#layer-privacy', {
					byClick: '.show_layer-privacy',
					cache: false
				}),
				$confidenceBox = $confidenceLayer.context(),
				$confidenceForm = $confidenceBox.find('.js-confidence-form'),
				$confidenceSubmit = $confidenceForm.find('.js-submit-btn'),
				$notShowCheckBox = $confidenceForm.find('.js-not-ahow-again'),
			// other
				confidenceURL = $confidenceForm.attr('action'),
				closeURL = $closeBtn.attr('href'),
			// classes
				disabledClass = 'disabled',
				socialUnitsIsHidden = 'socialUnits-is-hidden',
				confidenceIsHidden = 'confidence-is-hidden';

			// EVENTS
			$confidenceForm.on('submit', function (e) {
				e.preventDefault();
				if ($notShowCheckBox.is(':checked')) {
					$.ajax({
						url: confidenceURL,
						type: 'POST',
						dataType: 'json',
						beforeSend: function () {
							$confidenceSubmit.prop('disabled', true);
						},
						complete: function () {
							$confidenceLayer.close();
							$socialBottomBlock.addClass(confidenceIsHidden);
							var $slideBox = ($socialBottomBlock.hasClass(socialUnitsIsHidden) || !$socialUnitsBlock.is(':visible') ? $socialBottomBlock : $confidenceBlock);
							$slideBox.slideUp('fast', function () {
								$confidenceSubmit.prop('disabled', false);
							});
						}
					});
				} else {
					$confidenceLayer.close();
				}
			});
			$closeBtn.on('click', function (e) {
				e.preventDefault();
				if (!$closeBtn.hasClass(disabledClass)) {
					$.ajax({
						url: closeURL,
						type: 'POST',
						dataType: 'json',
						beforeSend: function () {
							$closeBtn.addClass(disabledClass);
						},
						complete: function () {
							$socialBottomBlock.addClass(socialUnitsIsHidden);
							var $slideBox = ($socialBottomBlock.hasClass(confidenceIsHidden) || !$confidenceBlock.is(':visible') ? $socialBottomBlock : $socialUnitsBlock);
							$slideBox.slideUp('fast', function () {
								$closeBtn.removeClass(disabledClass);
							});
						}
					});
				}
			});
		}());

	}, true);

	mambo.ready('{mambo.project}Anketa');
	
}, true);