/**
 * @copyright Mamba ( http://corp.mamba.ru/ )
 */

mambo.use('{mambo.ui}Overlay', '{mambo.ui}Input', '{mambo.ui}Alert', '{mambo.ui}Select', function () {


	mambo.project = mambo.project || {};

	mambo.project.Login = function (params) {
		params = $.extend(true, {
			lang: {
				error: 'Oops!'
			}
		}, params || {});


		var $Form = $('#LoginForm'),
			$clickUrl = $Form.find('input[name="clickUrl"]'),
			$target = $Form.find('input[name="target"]'),

			$Links = $('a.o-auth,div.o-auth,span.o-auth,area.o-auth'),
			$Forms = $('form.o-auth'),
			$Inputs = $Form.find('input'),

			$CaptchaStep = $('#LF-CapthcaStep'),
			$LoginStep = $('#LF-LoginStep'),
			$UnusualPlaceStep = $('#LF-UnusualPlace'),
			$steps = $CaptchaStep.add($LoginStep).add($UnusualPlaceStep),

			$CaptchaSubmit = $CaptchaStep.find('input[type="submit"]'),
			$LoginSubmit = $LoginStep.find(':submit'),
			$UnusualPlaceSubmit = $UnusualPlaceStep.find(':submit'),
			$submits = $CaptchaSubmit.add($LoginSubmit).add($UnusualPlaceSubmit),

			$CaptchaError = $CaptchaStep.find('.error'),
			$LoginTitle = $LoginStep.find('.login-title'),
			$CaptchaTitle = $CaptchaStep.find('.captcha-title'),
			$PhoneTitle = $UnusualPlaceStep.find('.phone-title'),

			$phoneInputs = $UnusualPlaceStep.find('input:text'),
			$CaptchaInput = $Inputs.filter('[name="login_captcha"]'),

			invalidClass = 'invalid',
			fInvalidClass = 'f-invalid',

			$NewLoginForm = $('#NewLoginForm'),
			newLoginFormFlag = $NewLoginForm.length ? 1 : 0,

			$tooltipError = $NewLoginForm.find('.js-tooltip-error'),
			$NewLoginInputs = $NewLoginForm.find('input.input-text'),

			redirect_url = params.redirect_url || undefined,
			oauthPage = params.oauthPage || false;

		var IDIVA_PARTNER = '1224087466';

		function isIdivaPartner() {
			return (mambo.partnerId == IDIVA_PARTNER);
		}

		function syncOldAndNewForms() {
			$NewLoginInputs.each(function () {
				var $NewLoginInput = $(this);
				$Form.find('[name=' + $NewLoginInput.attr('name') + ']').val($NewLoginInput.val());
			});
		}

		var $$OldNewForms = $NewLoginForm.add($Form);

		var layer = new mambo.ui.Overlay('#LoginForm');

		//получение новой ссылки на вход, блок показывается если пользователь пришёл по устаревшей ссылке
		var $box_link_sign_in = $(".boxLinkSignIn"),//обёртка блока
			$send_new_link_ok = $(".js-send_new_link_ok", $box_link_sign_in),
			$send_new_link_fail = $(".js-send_new_link_fail", $box_link_sign_in),
			$send_new_link = $(".js-send_new_link", $box_link_sign_in),
			send_new_link_url = $send_new_link.data("url");

		function setCaptchaImg($captchaWrapper) {// set captcha img
			var $captchaWrapper = $captchaWrapper || $Form;
			var $img = $captchaWrapper.find('.captchaPlace img');
			if (!$img.length) {
				var img = document.createElement('img');
				$img = $(img);

				var $place = $captchaWrapper.find('.captchaPlace');
				var url = $place.attr('rel') || '';

				var newSrc = url.replace(/\?r=\d+/, '?r=' + ((new Date()).valueOf()));

				img.setAttribute('src', newSrc);
				$place.html($img.css({
					opacity: 0.3,
					width: 150,
					height: 47
				}));

				$captchaWrapper.find('.HCaptcha').each(function () {
					if (!this.captcha) {
						this.captcha = 1;
						$(this).find('IMG,A').css('cursor', 'pointer').on('load', function (e) {
							$(this).css('opacity', 1);
						}).on('click', function (e) {
							$img.css('opacity', .3).attr('src', $img.attr('src').replace(/\?r=\d/, '?r=' + (new Date()).valueOf()));
							e.preventDefault();
						});
					}
				});
			} else {
				$img.css('opacity', .3).attr('src', $img.attr('src').replace(/\?r=\d/, '?r=' + (new Date()).valueOf()));
			}
		}

		function stepCaptcha() {
			if (newLoginFormFlag) {// if new login form is enebaled
				syncOldAndNewForms();
			}
			$submits.prop('disabled', true);
			$CaptchaSubmit.prop('disabled', false);

			setCaptchaImg($CaptchaStep);

			$steps.hide();
			$CaptchaStep.show();
			if (newLoginFormFlag && !params.no_layers) {// if new login form is enebaled
				if (!layer.isOpened()) {
					layer.open();
				}
			}
			$CaptchaInput.val('').focus();
		}

		function stepLogin() {
			if (newLoginFormFlag) {// if new login form is enebaled
				syncOldAndNewForms();
				if (layer.isOpened()) {
					layer.close();
				}
			}
			$submits.prop('disabled', true);
			$LoginSubmit.prop('disabled', false);
			$steps.hide();
			$LoginStep.show();
			if (newLoginFormFlag) {// if new login form is enebaled
				$NewLoginInputs.filter('[name="login"]').select().focus();
			} else {
				$Inputs.filter('[name="password"]').select().focus();
			}
		}

		function stepUnusualPlace() {
			if (newLoginFormFlag) {// if new login form is enebaled
				syncOldAndNewForms();
			}
			$submits.prop('disabled', true);
			$UnusualPlaceSubmit.prop('disabled', false);

			$steps.hide();
			$UnusualPlaceStep.show();
			if (newLoginFormFlag) {// if new login form is enebaled
				if (!layer.isOpened()) {
					layer.open();
				}
			}
		}

		function getValidateResult(input) {
			var $input = $(input);
			var inputName = $input.attr('name'),
				inputValue = $input.val();
			
			if (!$.trim(inputValue).length) {
				return false;
			}

			if (isIdivaPartner() && inputName == 'nick') {
				var EMAIL_REGEXP = /^[a-z0-9!#$%&'*+/=?^_`{|}~.-]+@[a-z0-9-]+\.[a-z0-9-]+$/i;
				if (!EMAIL_REGEXP.test(inputValue)) {
					return false;
				}
			}

			return true;
		}

		function getFormInputs($form) {
			return $form.find('input[name=login], input[name=nick], input[name=password]');
		}

		function validateField(input) {
			var $input = $(input),
				$field = $input.parent(),
				$error = $field.find('.error');

			var inputName = $input.attr('name'),
				inputValue = $input.val(),
				isValid = false;

			if (!getValidateResult(input)) {
				if(oauthPage){
					mambo.showErrorToolTip();
				}
				else {
					$field.addClass('invalid');
					$error.html(params.lang[inputName] ? params.lang[inputName] : '');						
				}

			} else {
				if(oauthPage){
					mambo.hideErrorToolTip();
				}
				else {
					$field.removeClass('invalid');					
				}		
				isValid = true;		
			}

			return isValid;
		};

		function validateFields($form) {
			var $inputs = getFormInputs($form);
			var isValid = true;

			$inputs.each(function () {
				var $input = $(this);

				if (!validateField($input)) {
					isValid = false;
				}
			});

			return isValid;
		};

		function bindValidateFields() {
			if (!newLoginFormFlag) return;

			var $form = $NewLoginForm;
			var $inputs = getFormInputs($form);

			$inputs.bind('input blur', function () {
				var $input = $(this);

				if ($form.data('tried')) {
					validateField($input);
				}
			});
		};


		function crossAuthStrategySend(dataCross) {
			var def = $.Deferred();
				$.ajax({
					url: params.crossAuthStrategy.url,
					type: "POST",
					dataType: "json",
					data: dataCross,
					/*xhrFields: {
						withCredentials: true
					},*/
					crossDomain: true, 
					cache: false,
					success: function (R) {
						if(R && R.crossAuthTokenId) {
							def.resolve(R);
						} else {
							def.reject();
						}
					},
					error: function () {
						def.reject();
					}
				});
			

			return def.promise();
		}

		function loginStart(e, self, data) {
			var $currentForm = self;
            var restart = false;

            // ставим таймер. Если пользователь потратит на ввод капчи больше 30 секунд,
            // crossAuthTokenId устрареет (срок жизни 30 секунд)
            // запустим все заново, но капчи уже не будет, т.к. юзер ее уже прошел
            var timerRestart = setTimeout(function() {
                restart = true;
            }, 30000); //30 секунд

			$.ajax({
				url: $currentForm.attr('action'),
				type: "POST",
				dataType: "json",
				cache: false,
				data: data,
				success: function (R) {

                    if (restart) {
                        //прошло более 30 секунд, crossAuthTokenId устрел, запускаем все заново
                        clearTimeout(timerRestart);
                        $$OldNewForms.trigger('submit');
                        return false;
                    }

					if (!R) {
						$submits.prop('disabled', false);
						$currentForm.removeClass('login-ajax-loading');
						return;
					} else if (R.r) {
						if (R.r.split('#')[0] == window.location.href.split('#')[0]) {
							window.location.reload();
						} else {
							window.location.href = (oauthPage && redirect_url)? redirect_url:R.r;
						}
						return;
					} else {
						$currentForm.removeClass('login-ajax-loading');
					}

					// unusual place step
					if (R.phone) {
						if (R.XForms.Login && R.XForms.Login && R.XForms.Login.login_phone) {
							$UnusualPlaceStep.addClass(fInvalidClass);
							$tooltipError.text(R.XForms.Login.login_phone);
						} else {
							$UnusualPlaceStep.removeClass(fInvalidClass);
						}
						if (R.d && R.d.phone_title) {
							$PhoneTitle.html(R.d.phone_title);
						} else {
							$PhoneTitle.html($PhoneTitle.attr('data-orig-text'));
						}
						if (R.d && R.d.phone_code) {
							$phoneInputs.filter('.phone-code').val(R.d.phone_code).prop('disabled', true);
						}

						stepUnusualPlace();
					}

					// captcha step
					if (R.captcha) {
						/* SET VIEW */
						if (R.XForms.Login && R.XForms.Login && R.XForms.Login.login_captcha) {
							$CaptchaError.html(R.XForms.Login.login_captcha);
							$CaptchaStep.addClass(invalidClass);
						} else {
							$CaptchaError.html('');
							$CaptchaStep.removeClass(invalidClass);
						}
						if (R.d && R.d.captcha_title) {
							$CaptchaTitle.html(R.d.captcha_title);
						} else {
							$CaptchaTitle.html($CaptchaTitle.attr('data-orig-text'));
						}

						// set step
						if (R.captcha != 'recaptcha') {// captcha
							stepCaptcha();
						}
					}

					// union of unusual place and captcha
					if (R.captcha && R.phone) {
						$UnusualPlaceSubmit.hide();
						$UnusualPlaceStep.show();
						$CaptchaStep.show();
					}

					// default
					if (!R.captcha && !R.phone) {
						if(oauthPage){
							mambo.showErrorToolTip();
						}
						if (R.XForms && R.XForms.Login && R.XForms.Login.found) {
							$LoginTitle.text(R.XForms.Login.found);
							$tooltipError.text(R.XForms.Login.found);
							$currentForm.addClass(fInvalidClass);
						} else {
							$LoginTitle.text($LoginTitle.attr('data-orig-text'));
						}


						stepLogin();
					}

					if (R.d && R.d.oauth_redirect) {
						if (window.opener) {
							window.opener.location = R.d.oauth_redirect;
							window.close();
						}
						else {
							window.location = R.d.oauth_redirect;
						}
						return;
					}

					/**
					 * closing opened popup login window on some circumstances
					 */ 
					if (window.opener && !R.XForms && !R.captcha && !R.captcha_ok) {
						window.opener.location.reload();
						window.close();
					}

					$Inputs.off('change.oldLoginForm click.oldLoginForm keypress.oldLoginForm').one('change.oldLoginForm click.oldLoginForm keypress.oldLoginForm', function (e) {
						$(this).parents().removeClass(fInvalidClass);
					});
				},
				error: function () {
					mambo.ui.Alert(params.lang.error, {
						type: 'red'
					});
				}
			});
		}
		

		//EVENTS
		layer.on('open', function () {
			$Inputs.filter('[name="login"]').select().focus();
		});
		$Forms.on('submit', function (e) {
			e.preventDefault();
			layer.open();
		});
		$Links.removeAttr('onclick').live('click', function (e) {
			e.preventDefault();
			if (this.target === '_blank') {
				$clickUrl.val(window.location.href || '');
			} else {
				$clickUrl.val(this.href || '');
			}
			var target = this.className.match(/ot-(\w+)/);
			target = target ? target[1] : null;
			if (mambo && mambo.noAuthLayer && mambo.noAuthUrl.length) {
				var oAuthRedirect = mambo.noAuthUrl;
				if (target) {
					oAuthRedirect = oAuthRedirect + '&reason=' + target;
				}
                if (mambo.vUserId) {
                    switch (target) {
                        case 'vippresent':
                            oAuthRedirect += '&goto=anketa-vip-present_' + mambo.vUserId;
                            break;

                        case 'gift':
                            oAuthRedirect += '&goto=anketa-gift_' + mambo.vUserId;
                            break;

                        default:
                            oAuthRedirect += '&goto=anketa_' + mambo.vUserId;
                            break;
                    }
				}
				window.location.href = oAuthRedirect;
			}
			else {
				$target.val(target || '');
				$Form.find('h3').hide().filter('.' + (target || 'base')).show();
				layer.open();
			}
		});
		$phoneInputs.on("keydown", function (e) {
			var $this = $(this);
			if (!(e.keyCode <= 57 || e.keyCode >= 96 && e.keyCode <= 105)) {
				e.preventDefault();
			}
		});
		$CaptchaInput.on("keydown", function (e) {
			if (e.keyCode <= 57 || e.keyCode >= 96 && e.keyCode <= 105) {
				$CaptchaStep.removeClass(invalidClass);
			}
		});
		
		// old and new login form submit events
		$$OldNewForms.on('submit', function (e) {
			
			var $currentForm = $(this);
			
			if (isIdivaPartner()) {
				if (validateFields($currentForm)) {
					return true;
				} else {
					return;
				}
			}


			if (params.noUseAjax) {
				return true;
			}
			
			e.preventDefault();

			if (newLoginFormFlag && $currentForm.hasClass(fInvalidClass) && !oauthPage) {
				return;
			}

			$currentForm.data('tried', true);

			if (!validateFields($currentForm) && !oauthPage) {
				return;
			}

            var formData = {}, p = mambo.utils.getLocationParams();
            $currentForm.serializeArray().map(function (i) {
                formData[i.name] = i.value;
            });
            if (p.goto) formData.goto = p.goto;

            $currentForm.addClass('login-ajax-loading');
            $submits.prop('disabled', true);

            if (params && params.crossAuthStrategy && params.crossAuthStrategy.enabled) {
                crossAuthStrategySend(formData).done(function (data) {
                    if (formData.goto) data.goto = formData.goto;
                    loginStart(e, $currentForm, data);
                })
            } else {
                loginStart(e, $currentForm, formData);
            }
        });

		//Begin send new link to sign in
		$send_new_link.on("click", function (e) {
			e.preventDefault();
			$.ajax({
				url: send_new_link_url || '?',
				type: 'POST',
				dataType: 'json',
				cache: false,
				data: '',
				beforeSend: function () {
					$send_new_link.prop('disabled', true);
					$send_new_link_fail.hide();
				},
				success: function (R) {
					if (R.s) {
						if (!R.r) {
							//ссылка отправлена
							$send_new_link.hide();
							$send_new_link_ok.show();
						}
					}
					else {
						$send_new_link_fail.html(R.error);
						$send_new_link_fail.show();
					}
				},
				complete: function () {
					$send_new_link.prop('disabled', false);
				}
			});
		});
		//End send new link to sign in

		/* START NEW LOGIN FORM EVENTS */
		$NewLoginInputs.off('input.newLoginForm').on('input.newLoginForm', function (e) {
			$NewLoginForm.removeClass(fInvalidClass);
		});
		/* END NEW LOGIN FORM EVENTS */
		/* LOGIN BOX */
		function loginBox() {
			var $box = $('._boxFormWrapper');
			if (!$box.length) {
				return;
			}
			var $link = $('.changeBoxContainer', $box);
			var $container = $('.boxContainer', $box);
			// EVENTS
			$link.on('click', function (e) {
				e.preventDefault();
				$container.toggle();
			});
			// SET VIEW
			$('#RegBlockForm').hide();
		}

		function loginBoxAlpha() {
			var $box = $('.box-login');
			var $link = $('.changeBoxContainer', $box);
			var $containerWrapper = $('.boxContainerWrapper', $box);
			var $container = $('.boxContainer', $box);
			var colorBox = $('.color-on');
			var colorClass = {
				color1: 'box-login-color1',
				color2: 'box-login-color2'
			};
			var $arrowEl = $('.js-arrow-el'),
				$tabEl = $('.js-tab-item'),
				currentDirection = mambo.langIsRTL ? 'right' : 'left',
				animationValues = {
					'opacity': 0
				},
				arrowOffset = $tabEl.first().outerWidth(true)/2 + $tabEl.last().outerWidth(true)/2 + 5;

			if (!$container.length) {
				return;
			}

			// EVENTS
			$link.on('click', function (e) {
				e.preventDefault();

				if ($(this).parent().hasClass('active')) {
					return;
				}

				if ($containerWrapper.is(':animated')) return;

				var $visibleForm = $container.filter(':visible').first();
				var $hiddenForm = $container.filter(':hidden').first();

				var slideDirection = ($visibleForm.prev().length) ? 0 : 1;
				var slideWidth = $visibleForm.width();
				var slideDuration = 400,
					isFirstTab = $(this).parent().is(':first-child');
				
				setTimeout(function() {
					$link.parent().toggleClass('active');
				}, slideDuration);
				
				if ($arrowEl.is('.js-arrow-reg')) {
					$arrowEl.css('margin-'+currentDirection, isFirstTab ? 0 : arrowOffset);
				} else {
					$arrowEl.css('margin-'+currentDirection, isFirstTab ? -arrowOffset : 0);
				}

				// Animate form
				$containerWrapper.height($visibleForm.height());
				$container.show().each(function (index) {
					$(this).css({
						'position': 'absolute',
						'width': slideWidth,
						'opacity': 1,
						currentDirection: index * slideWidth - (!slideDirection * slideWidth)
					});
				});
				
				$containerWrapper.animate({
					'height': $hiddenForm.height()
				}, slideDuration, function () {
					$(this).height('auto');
				});
				
				animationValues[currentDirection] = parseInt($visibleForm.css(currentDirection)) + ((slideDirection ? -1 : 1) * slideWidth); 

				$visibleForm.animate(animationValues, {
					'duration': slideDuration,
					'step': function (now, fx) {
						if (mambo.langIsRTL) {
							if (fx.prop == 'right') {
								$hiddenForm.css({
									'right': now + ((slideDirection ? 1 : -1) * slideWidth)
								});
							}
						} else {
							if (fx.prop == 'left') {
								$hiddenForm.css({
									'left': now + ((slideDirection ? 1 : -1) * slideWidth)
								});
							}
						}
					},
					'complete': function () {
						$visibleForm.hide();
						$hiddenForm.show();
						$container.css({
							position: 'static',
							width: 'auto'
						});
					}
				});

				var curColor = colorBox.hasClass(colorClass.color1);
				colorBox.toggleClass(colorClass.color2, curColor);
				colorBox.toggleClass(colorClass.color1, !curColor);
			});

			// SET VIEW
			$('#RegBlockForm').hide();
		}

		// INIT LOGIN
		if (params.unusualPlace && parseInt(params.unusualPlace)) {// unusualPlace
			stepUnusualPlace();
		}
		else if (!params.no_init) {// default
			stepLogin();
		}
		
		// OTHER INIT
		if ($('.box-login').length) {
			loginBoxAlpha();
		} else {
			loginBox();
		}

		// TODO fix placeholder for hidden field
		if ($NewLoginForm.is(':hidden')) {
			$NewLoginInputs.filter('[name="login"]').focus().blur();
		}

		bindValidateFields();
	};

	mambo.ready('{mambo.project}Login');
}, true);