/**
 * Created by asidorov on 23.09.14.
 */

mambo.use('{jQuery}jquery.mousewheel', function(){

	$.fn.nicescrollbar = function(options){
		options = options || {};
		var niceScrollbarCSSSelector = options.niceScrollbarCSSSelector;
		var niceScrollbarCSSClass = niceScrollbarCSSSelector || ('.' + options.niceScrollbarCSSClass || '.js-nicescrollbar');
		var niceScrollbarIE8CSSClass = options.niceScrollbarIE8CSSClass || 'js-nicescrollbar-ie8';
		var niceScrollbarRunnerCSSClass = options.niceScrollbarRunnerCSSClass || 'js-nicescrollbar-runner';
		var niceScrollType = options.niceScrollType || 'HORIZONTAL';
        var isMacOS = navigator.platform.match(/^Mac/i) ? true : false;
		var niceScrollStep = isMacOS? 15 : (options.niceScrollStep || 150);

		var $scrollableElement = $(this);
		var $niceScrollbar = $(niceScrollbarCSSClass);
		var $niceScrollbarRunner = $niceScrollbar.find('.' + niceScrollbarRunnerCSSClass);

		var coeffs = {vertical: 0, horizontal: 0};

		if ($.browser.msie8) {
			$niceScrollbar.addClass(niceScrollbarIE8CSSClass);
		}

		$scrollableElement.on('updatenicescrollbar', function(event){
			if (niceScrollType === 'VERTICAL') {
				updateVerticalScrollbar($scrollableElement, $niceScrollbar, $niceScrollbarRunner, coeffs);
			} else if (niceScrollType === 'HORIZONTAL') {
				updateHorizontalScrollbar($scrollableElement, $niceScrollbar, $niceScrollbarRunner, coeffs);
			}
			return $scrollableElement;
		});

		$scrollableElement.on('setnicescrollbar', function(event, newValue){
			newValue *= 1;
			if (isNaN(newValue)) {
				return $scrollableElement;
			}
			if (niceScrollType === 'VERTICAL') {
				setVerticalScrollbar($scrollableElement, $niceScrollbarRunner, newValue, coeffs);
			} else if (niceScrollType === 'HORIZONTAL') {
				setHorizontalScrollbar($scrollableElement, $niceScrollbarRunner, newValue, coeffs);
			}
			return $scrollableElement;
		});

		$scrollableElement.on('mousewheel DOMMouseScroll MozMousePixelScroll', function(event){
            var delta = parseInt(event.originalEvent.deltaY || event.originalEvent.detail);

			var $self = $(this);
			var deltaY = - delta;
			var newTop = 0;
			var newLeft = 0;

			if (!coeffs.vertical && !coeffs.horizontal) {
				return;
			}

			if (niceScrollType === 'VERTICAL') {
				if (deltaY > 0) {
					newTop = $self.scrollTop() - niceScrollStep;
				} else if (deltaY < 0) {
					newTop = $self.scrollTop() + niceScrollStep;
				}
				if (deltaY !== 0) {
					setVerticalScrollbar($self, $niceScrollbarRunner, newTop, coeffs);
				}
			} else if (niceScrollType === 'HORIZONTAL') {
				if (deltaY > 0) {
					newLeft = $self.scrollLeft() - niceScrollStep;
				} else if (deltaY < 0) {
					newLeft = $self.scrollLeft() + niceScrollStep;
				}
				if (deltaY !== 0) {
					setHorizontalScrollbar($self, $niceScrollbarRunner, newLeft, coeffs);
				}
			}
			event.preventDefault();
			event.stopPropagation();
		});

		$niceScrollbar.mousedown(function(event){
			var initClientY = event.clientY;
			var currentTop = $scrollableElement.scrollTop();

			var initClientX = event.clientX;
			var currentLeft = $scrollableElement.scrollLeft();

			var mousemoveHandler = function(){};

			if (niceScrollType === 'VERTICAL') {
				mousemoveHandler = function(event) {
					var clientY = event.clientY;
					setVerticalScrollbar($scrollableElement, $niceScrollbarRunner, currentTop + (clientY - initClientY)*coeffs.vertical, coeffs);
				};
			} else if (niceScrollType === 'HORIZONTAL') {
				mousemoveHandler = function(event) {
					var clientX = event.clientX;
					setHorizontalScrollbar($scrollableElement, $niceScrollbarRunner, currentLeft + (clientX - initClientX)*coeffs.horizontal, coeffs);
				};
			}

			var mouseupHandler = function(event) {
				$(document).off('mousemove', mousemoveHandler);
				$(document).off('mouseup', mouseupHandler);
			};

			$(document).on('mousemove', mousemoveHandler);
			$(document).on('mouseup', mouseupHandler);

			// Disable text selection and stop event propagation
			return false;
		});

		$scrollableElement.triggerHandler('updatenicescrollbar');
		return $scrollableElement;
	};

	var updateVerticalScrollbar = function($scrollableElement, $niceScrollbar, $niceScrollbarRunner, coeffs) {
		var scrollableScrollHeight = $scrollableElement.get(0).scrollHeight;
		var scrollableHeight = $scrollableElement.innerHeight();
		coeffs.vertical = scrollableScrollHeight / scrollableHeight;
		if (!coeffs.vertical) {
			return;
		}
		var deltaScroll = (scrollableScrollHeight - scrollableHeight) / coeffs.vertical; // How many pixels left to scroll;
		var niceScrollbarHeight = $niceScrollbar.height();

		if (scrollableScrollHeight === scrollableHeight) {
			$niceScrollbarRunner.css('height', '0px');
			$niceScrollbar.hide();
		} else {
			$niceScrollbarRunner.css('height', niceScrollbarHeight - deltaScroll + 'px');
			$niceScrollbar.show();
		}
	};

	var updateHorizontalScrollbar = function($scrollableElement, $niceScrollbar, $niceScrollbarRunner, coeffs) {
		var scrollableScrollWidth = $scrollableElement.get(0).scrollWidth;
		var scrollableWidth = $scrollableElement.innerWidth();
		coeffs.horizontal = scrollableScrollWidth / scrollableWidth;
		if (!coeffs.horizontal) {
			return;
		}
		var deltaScroll = (scrollableScrollWidth - scrollableWidth) / coeffs.horizontal; // How many pixels left to scroll;
		var niceScrollbarWidth = $niceScrollbar.width();

		if (scrollableScrollWidth === scrollableWidth) {
			$niceScrollbarRunner.css('width', '0px');
			$niceScrollbar.hide();
		} else {
			$niceScrollbarRunner.css('width', niceScrollbarWidth - deltaScroll + 'px');
			$niceScrollbar.show();
		}
	};

	var setVerticalScrollbar = function($scrollableElement, $niceScrollbarRunner, newTop, coeffs) {
		if (isNaN(newTop) || !coeffs.vertical) {
			return;
			//throw new Error('[' + newTop + ' is not a number]');
		}
		$scrollableElement.scrollTop(newTop);
		$niceScrollbarRunner.css('top', $scrollableElement.scrollTop() / coeffs.vertical + 'px');
	};

	var setHorizontalScrollbar = function($scrollableElement, $niceScrollbarRunner, newLeft, coeffs) {
		if (isNaN(newLeft) || !coeffs.horizontal) {
			return;
			//throw new Error('[' + newLeft + ' is not a number]');
		}
		$scrollableElement.scrollLeft(newLeft);
		$niceScrollbarRunner.css('left', $scrollableElement.scrollLeft() / coeffs.horizontal + 'px');
	};

	mambo.ready('{jQuery}jquery.nicescrollbar');
});
